<script type="text/javascript" src="{$before_path}/modules/addons/puq_customization/extensions/AccountStatement/templates/daterangepicker/moment.min.js"></script>
<script type="text/javascript" src="{$before_path}/modules/addons/puq_customization/extensions/AccountStatement/templates/daterangepicker/daterangepicker.min.js"></script>
<link rel="stylesheet" type="text/css" href="{$before_path}/modules/addons/puq_customization/extensions/AccountStatement/templates/daterangepicker/daterangepicker.css" />

<form method="post" action="{$before_path}/index.php?m=puq_customization&e=account_statement">
    <div class="card">
        <div class="card-body">
            <h3 class="card-title">{$lang['Account Statement']}</h3>

            <div class="row d-md-block">
                <div class="col-md-6 float-md-left">
                    <div class="form-group">
                        <label for="statement_date" class="col-form-label">{$lang['Date range']}</label>
                        <div style="background: #fff; cursor: pointer; padding: 5px 10px; border: 1px solid #ccc; width: 100%" >
                            <i class="fa fa-calendar"></i>&nbsp;
                            <input id="reportrange" name="statement_date" value="{$post['statement_date']}" style="width: 90%; border: none;">
                            <span></span>
                        </div>
                    </div>
                </div>

                <div class="col-md-6 col-12 float-md-right">
                    <div class="card-body">
                        <h3 class="card-title">{$lang['Content']}</h3>

                        <div class="controls form-check">
                            <label class="checkbox-inline">
                                <input type="checkbox" name="paid_invoices" {if $post['paid_invoices']}checked{/if}> &nbsp; {$lang['Paid invoices']}
                            </label><br>
                            <label class="checkbox-inline">
                                <input type="checkbox" name="unpaid_invoices" {if $post['unpaid_invoices']}checked{/if}> &nbsp; {$lang['Unpaid invoices']}
                            </label><br>
                            <label class="checkbox-inline">
                                <input type="checkbox" name="refunded_invoices" {if $post['refunded_invoices']}checked{/if}> &nbsp; {$lang['Refunded invoices']}
                            </label><br>
                            <label class="checkbox-inline">
                                <input type="checkbox" name="transactions" {if $post['transactions']}checked{/if}> &nbsp; {$lang['Transactions']}
                            </label><br>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="form-group text-center">
            <button type="submit" name="submit" value="view" class="btn btn-primary"><i class="fa fa-eye"> </i> &nbsp; {$lang['View']}</button>
            <button type="submit" name="submit" value="download_pdf" class="btn btn-info"><i class="fa fa-download"> </i> &nbsp; {$lang['Download PDF']}</button>
        </div>
    </div>
</form>

{literal}
<script type="text/javascript">
    $(function() {
        const translations = {
            Today: '{/literal}{$lang['Today']}{literal}',
            Yesterday: '{/literal}{$lang['Yesterday']}{literal}',
            Last7Days: '{/literal}{$lang['Last 7 Days']}{literal}',
            Last30Days: '{/literal}{$lang['Last 30 Days']}{literal}',
            ThisMonth: '{/literal}{$lang['This Month']}{literal}',
            LastMonth: '{/literal}{$lang['Last Month']}{literal}',
            LastYear: '{/literal}{$lang['Last Year']}{literal}',
            ThisYear: '{/literal}{$lang['This Year']}{literal}',
            Apply: '{/literal}{$lang['Apply']}{literal}',
            Cancel: '{/literal}{$lang['Cancel']}{literal}',
            From: '{/literal}{$lang['From']}{literal}',
            To: '{/literal}{$lang['To']}{literal}',
            Custom: '{/literal}{$lang['Custom']}{literal}',
            WeekLabel: '{/literal}{$lang['W']}{literal}',
            DaysOfWeek: moment.weekdaysMin(),
            MonthNames: moment.monthsShort(),
            FirstDay: moment.localeData().firstDayOfWeek()
        };

        const dateRange = '{/literal}{$post['statement_date']}{literal}';
        const dates = dateRange.split(" - ");
        var start = moment(dates[0]);
        var end = moment(dates[1]);

        if (dateRange === '') {
            start = moment().subtract(1, 'month').startOf('month');
            end = moment().subtract(1, 'month').endOf('month');
        }

        function cb(start, end) {
            $('#reportrange span').html(start.format('MMMM, D, YYYY') + ' - ' + end.format('MMMM, D, YYYY'));
        }

        $('#reportrange').daterangepicker({
            startDate: start,
            endDate: end,
            showDropdowns: true,
            minYear: 2000,
            maxYear: parseInt(moment().format('YYYY'), 10),
            ranges: {
                [translations.Today]: [moment(), moment()],
                [translations.Yesterday]: [moment().subtract(1, 'days'), moment().subtract(1, 'days')],
                [translations.Last7Days]: [moment().subtract(6, 'days'), moment()],
                [translations.Last30Days]: [moment().subtract(29, 'days'), moment()],
                [translations.ThisMonth]: [moment().startOf('month'), moment().endOf('month')],
                [translations.LastMonth]: [moment().subtract(1, 'month').startOf('month'), moment().subtract(1, 'month').endOf('month')],
                [translations.LastYear]: [moment().subtract(1, 'year').startOf('year'), moment().subtract(1, 'year').endOf('year')],
                [translations.ThisYear]: [moment().startOf('year'), moment().endOf('year')]
            },
            locale: {
                format: 'YYYY-MM-DD',
                separator: ' - ',
                applyLabel: translations.Apply,
                cancelLabel: translations.Cancel,
                fromLabel: translations.From,
                toLabel: translations.To,
                customRangeLabel: translations.Custom,
                weekLabel: translations.WeekLabel,
                daysOfWeek: translations.DaysOfWeek,
                monthNames: translations.MonthNames,
                firstDay: translations.FirstDay,
            },
            opens: 'right'
        }, cb);

        cb(start, end);
    });
</script>
{/literal}

{if $summary}
    <a id="summary_start"></a>

    <div class="card">
        <table class="table table-list dataTable no-footer" style="text-align: center;">
            <tbody>
            <tr>
                <th colspan="4" style="text-align: center; font-size: 20px;"><b>{$lang['Statement Period']}: {$summary['start_date']} - {$summary['end_date']} </b>
                </th>
            </tr>

            <tr style="text-align: center;">
                <td><b>{$lang['Available credit']}: {$summary['credit_currency']}</b></td>
                <td>{$lang['Contained']}</td>
                <td>{$lang['Quantity']}</td>
                <td style="text-align: left;">{$lang['Amount']}</td>
            </tr>

            <tr style="text-align: center;">
                <td style="text-align: right;" >{$lang['Open Balance']}</td>
                <td></td>
                <td></td>
                <td style="text-align: left;">{$summary['open_currency_balance']}</td>
            </tr>
            {if $summary['invoices_paid'] eq 'yes'}
                <tr style="text-align: center;">
                    <td style="text-align: right;" >{$lang['Paid invoices']}</td>
                    <td>{$lang[$summary['invoices_paid']]}</td>
                    <td>{$summary['number_invoices_paid']}</td>
                    <td style="text-align: left;">{$summary['total_currency_invoices_paid']}</td>
                </tr>
            {/if}

            {if $summary['invoices_unpaid'] eq 'yes'}
                <tr style="text-align: center;">
                    <td style="text-align: right;" >{$lang['Unpaid invoices']}</td>
                    <td>{$lang[$summary['invoices_unpaid']]}</td>
                    <td>{$summary['number_invoices_unpaid']}</td>
                    <td style="text-align: left;">{$summary['total_currency_invoices_unpaid']}</td>
                </tr>
            {/if}

            {if $summary['invoices_refunded'] eq 'yes'}
                <tr style="text-align: center;">
                    <td style="text-align: right;" >{$lang['Refunded invoices']}</td>
                    <td>{$lang[$summary['invoices_refunded']]}</td>
                    <td>{$summary['number_invoices_refunded']}</td>
                    <td style="text-align: left;">{$summary['total_currency_invoices_refunded']}</td>
                </tr>
            {/if}

            {if $summary['transactions'] eq 'yes'}
                <tr style="text-align: center;">
                    <td style="text-align: right;" >{$lang['Incoming transactions']}</td>
                    <td>{$lang[{$summary['transactions']}]}</td>
                    <td>{$summary['number_transactions_in']}</td>
                    <td style="text-align: left;">{$summary['total_currency_transactions_in']}</td>
                </tr>

                <tr style="text-align: center;">
                    <td style="text-align: right;" >{$lang['Outgoing transactions']}</td>
                    <td>{$lang[{$summary['transactions']}]}</td>
                    <td>{$summary['number_transactions_out']}</td>
                    <td style="text-align: left;">{$summary['total_currency_transactions_out']}</td>
                </tr>
            {/if}

            <tr style="text-align: center;">
                <td style="text-align: right;" >{$lang['Adding credit']}</td>
                <td>{$lang['yes']}</td>
                <td>{$summary['number_credit_addition']}</td>
                <td style="text-align: left;">{$summary['total_currency_credit_addition']}</td>
            </tr>

            <tr style="text-align: center;">
                <td style="text-align: right;" >{$lang['Using credit']}</td>
                <td>{$lang['yes']}</td>
                <td>{$summary['number_credit_removal']}</td>
                <td style="text-align: left;">{$summary['total_currency_credit_removal']}</td>
            </tr>

            <tr style="text-align: center;">
                <td style="text-align: right;" >{$lang['Closing Balance']}</td>
                <td></td>
                <td></td>
                <td style="text-align: left;">{$summary['closing_currency_balance']}</td>
            </tr>

            </tbody>
        </table>

        {if $statement}
            <style>
                .puq_pagination {
                    display: flex;
                    justify-content: center;
                    align-items: center;
                    margin-top: 10px;
                }
                .puq_pagination .rowsPerPage {
                    white-space: nowrap;
                    margin: 0 10px;
                    height: 30px;
                }
                .puq_pagination label {
                    font-weight: bold;
                    margin-right: 5px;
                }
                .puq_pagination .page_link:hover {
                    background-color: #ccc;
                }
                .puq_pagination .page_link {
                    margin: 10px;
                    display: inline-block;
                    padding: 5px 10px;
                    background-color: #e0e0e0;
                    color: #333;
                    text-decoration: none;
                }
                .puq_pagination .active_page {
                    color: #000000;
                    background-color: #bcbcbc;
                    font-weight: bold;
                }
            </style>
            <div class="puq_pagination">
                <div id="pagination"></div>
                <div class="rowsPerPage">
                    <label for="rowsPerPage">{$lang['Rows per page']}:</label>
                    <select id="rowsPerPage" onchange="updatePagination()">
                        <option value="10">10</option>
                        <option value="20">20</option>
                        <option value="50">50</option>
                        <option value="100">100</option>
                        <option value="all">{$lang['All']}</option>
                    </select>
                </div>
            </div>

            <table id="statement" class="table table-striped" style="width: 100%;">
                <tr class="header" style="text-align: center;">
                    <th>{$lang['Date']}</th>
                    <th>{$lang['Type']}<br>{$lang['Status']}</th>
                    <th style="white-space: nowrap;">{$lang['Trans. ID']} <br> {$lang['Inv. ID']}</th>
                    <th>{$lang['Description']}</th>
                    <th>{$lang['Total']}</th>
                    <th>{$lang['Debit']}</th>
                    <th>{$lang['Credit']}</th>
                    <th>{$lang['Pay. Method']}</th>
                </tr>
                {foreach from=$statement key=k item=record}
                    <tr>
                        <td>{$record['date']}</td>
                        <td>{$record['type']}<br><span style="color: {$record['color']};">{$record['status']}</span></td>
                        <td>{$record['transid']} <br> {$record['invoiceid']}</td>
                        <td>{$record['description']}</td>
                        <td style="color: {$record['color']}; white-space: nowrap;">{$record['total_currency']}</td>
                        <td style="color: {$record['color']}; white-space: nowrap;">{$record['debit']}</td>
                        <td style="color: {$record['color']}; white-space: nowrap;">{$record['credit']}</td>
                        <td>{$record['gateway']}</td>
                    </tr>
                {/foreach}
            </table>

            <script>
                var currentPage = 1;
                var rowsPerPage = 10;
                var table = document.getElementById('statement');
                var totalRows = table.rows.length - 1;
                var totalPages = Math.ceil(totalRows / rowsPerPage);

                function updatePagination() {
                    var rowsPerPageSelect = document.getElementById('rowsPerPage');
                    rowsPerPage = rowsPerPageSelect.value === 'all' ? totalRows : parseInt(rowsPerPageSelect.value, 10);
                    totalPages = Math.ceil(totalRows / rowsPerPage);
                    currentPage = 1;
                    paginateTable(currentPage, rowsPerPage);
                    renderPagination(currentPage, totalPages);
                }

                function paginateTable(currentPage, rowsPerPage) {
                    var startIndex = (currentPage - 1) * rowsPerPage;
                    var endIndex = currentPage * rowsPerPage;

                    Array.from(table.rows).forEach(function(row, index) {
                        if (index === 0) {
                            return;
                        }

                        if (index > startIndex && index <= endIndex) {
                            row.style.display = 'table-row';
                        } else {
                            row.style.display = 'none';
                        }
                    });
                }

                function renderPagination(currentPage, totalPages) {
                    var paginationElement = document.getElementById('pagination');
                    var paginationHTML = '';

                    for (var i = 1; i <= totalPages; i++) {
                        if (i === currentPage) {
                            paginationHTML += '<a class="page_link active_page" href="#" data-page="' + i + '">' + i + '</a> ';
                        } else {
                            paginationHTML += '<a class="page_link" href="#" data-page="' + i + '">' + i + '</a> ';
                        }
                    }
                    paginationElement.innerHTML = paginationHTML;
                    var pageLinks = paginationElement.getElementsByTagName('a');
                    for (var j = 0; j < pageLinks.length; j++) {
                        pageLinks[j].addEventListener('click', function(event) {
                            event.preventDefault();
                            currentPage = parseInt(this.getAttribute('data-page'), 10);
                            paginateTable(currentPage, rowsPerPage);
                            renderPagination(currentPage, totalPages);
                        });
                    }
                }
                updatePagination();
                var anchor = document.getElementById('summary_start');
                anchor.scrollIntoView();
            </script>

        {else}
            <h1 style="text-align: center;">{$lang['No data to show']}</h1>
        {/if}
    </div>
{/if}