<h3>{$lang['Edit Zone (hestiacp)']}</h3>

<form method="post" action="{$before_path}/admin/addonmodules.php?module=puq_customization&extension=module_puq_proxmox_kvm&action=dns_zones">

    <table class="form" width="100%" border="0" cellspacing="2" cellpadding="3">
        <tbody>

        <tr>
            <td class="fieldlabel">{$lang['Zone']}</td>
            <td class="fieldarea">
                <input type="hidden" name="id" value="{$dns_zone['id']}">
                <input type="hidden" name="type" value="hestiacp">
                <input type="text" name="zone" value="{$dns_zone['zone']}" class="form-control input-inline input-400" required><br>
                {$lang['Forward zone: example.com']}<br>
                {$lang['Reverse zone IPv4: 100.51.198.in-addr.arpa (IPv4 prefix: 198.51.100.0/24)']}<br>
                {$lang['Reverse zone IPv6: d.c.b.a.d.c.b.a.d.c.b.a.8.b.d.0.1.0.0.2.ip6.arpa (IPv6 prefix: 2001:0db8:abcd:abcd:abcd:abcd:abcd:0000/112)']}
            </td>
        </tr>

        <tr>
            <td class="fieldlabel">{$lang['Hestiacp server']}</td>
            <td class="fieldarea">
                <input type="text" name="server" value="{$dns_zone['server']}" class="form-control input-inline input-400" required><br>
                {$lang['Hestiacp server: https://example.com:8083/']}
            </td>
        </tr>

        <tr>
            <td class="fieldlabel">{$lang['Hestiacp admin user']}</td>
            <td class="fieldarea">
                <input type="text" name="admin_user" value="{$dns_zone['admin_user']}" class="form-control input-inline input-400" required><br>
                {$lang['Server administrator username']}
            </td>
        </tr>

        <tr>
            <td class="fieldlabel">{$lang['Hestiacp admin password']}</td>
            <td class="fieldarea">
                <input type="text" name="admin_password" value="{$dns_zone['admin_password']}" class="form-control input-inline input-400" required><br>
                {$lang['Server administrator user password']}
            </td>
        </tr>

        <tr>
            <td class="fieldlabel">{$lang['User']}</td>
            <td class="fieldarea">
                <input type="text" name="user" value="{$dns_zone['user']}" class="form-control input-inline input-400" required><br>
                {$lang['The user who will be the holders of the DNS zones']}
            </td>
        </tr>

        </tbody>
    </table>
    <div class="btn-container">
        <button type="submit" name="submit" value="edit_dns_zone" class="btn btn-primary">{$lang['Edit Zone']}</button>
        <button type="submit" name="submit" value="test_dns_zone" class="btn btn-default">{$lang['Test Zone']}</button>
        <button type="submit" name="submit" value="delete_dns_zone" class="btn btn-danger" onclick="return confirm('{$lang['Are you sure you want to delete?']}')" >{$lang['Delete Zone']}</button>
    </div>
</form>

{if $test_dns_zone}
<pre>{$test_dns_zone|print_r}</pre>
{/if}
